#version 330 core

layout(location = 0) in vec3 pos;
layout(location = 1) in vec2 tex;
layout(location = 2) in vec2 notUsedTex;
layout(location = 3) in vec3 normal;

out vec2 UV;
out vec3 PosWorld;
out vec3 NormalView;

uniform mat4 	mvp;
uniform mat4 	modelMat;

void main()
{
	gl_Position	= mvp * vec4(pos,1);
	UV			= tex;
	PosWorld	= (modelMat * vec4(pos,1)).xyz;
	NormalView	= (transpose(inverse(modelMat)) * vec4(normal, 0)).xyz;
}
