#version 330 core

layout(location = 0) in vec3 vertexPos;
layout(location = 1) in vec2 UV;

in vec2 position;

out vec4 clipSpace;
out vec2 textureCoords;

uniform mat4 mvp;
uniform vec4 plane;

const float tiling = 2.0;

void main(){
	clipSpace = mvp * vec4(vertexPos,1);
	gl_ClipDistance[0] = dot(clipSpace, plane);
    gl_Position = clipSpace;
	textureCoords = (vec2(position.x, position.y) / 2.0 + 0.5) * tiling;
}