#version 330 core

layout(location = 0) in vec3 pos;
layout(location = 1) in vec2 diffuseTex;
layout(location = 2) in vec2 lightMapTexture;
layout(location = 3) in vec3 normal;

out vec3 PosWorld;
out vec2 DiffuseTex;
out vec2 LightMapTexture;
out vec3 NormalView;

uniform mat4 	mvp;
uniform mat4 	modelMat;

void main()
{
	gl_Position		= mvp * vec4(pos,1);
	DiffuseTex		= diffuseTex;
	LightMapTexture = lightMapTexture;
	PosWorld		= (modelMat * vec4(pos,1)).xyz;
	NormalView		= (transpose(inverse(modelMat)) * vec4(normal, 0)).xyz;
}
